diff --git a/drivers/infiniband/hw/i40iw/i40iw_verbs.c b/drivers/infiniband/hw/i40iw/i40iw_verbs.c
index 102875872bea..ee2061298e7c 100644
--- a/drivers/infiniband/hw/i40iw/i40iw_verbs.c
+++ b/drivers/infiniband/hw/i40iw/i40iw_verbs.c
@@ -2740,6 +2740,50 @@ static const struct cpumask *i40iw_get_vector_affinity(struct ib_device *ibdev,
 	return irq_get_affinity_mask(msix_vec->irq);
 }
 
+static const struct ib_device_ops i40iw_dev_ops = {
+	/* Device operations */
+	.query_device = i40iw_query_device,
+	.get_dev_fw_str = i40iw_get_dev_fw_str,
+	.get_vector_affinity = i40iw_get_vector_affinity,
+	/* Port operations */
+	.query_port = i40iw_query_port,
+	.get_port_immutable = i40iw_port_immutable,
+	/* PKey operations */
+	.query_pkey = i40iw_query_pkey,
+	/* GID operations */
+	.query_gid = i40iw_query_gid,
+	/* Ucontext operations */
+	.alloc_ucontext = i40iw_alloc_ucontext,
+	.dealloc_ucontext = i40iw_dealloc_ucontext,
+	.mmap = i40iw_mmap,
+	/* PD operations */
+	.alloc_pd = i40iw_alloc_pd,
+	.dealloc_pd = i40iw_dealloc_pd,
+	/* QP operations */
+	.create_qp = i40iw_create_qp,
+	.modify_qp = i40iw_modify_qp,
+	.query_qp = i40iw_query_qp,
+	.destroy_qp = i40iw_destroy_qp,
+	.post_send = i40iw_post_send,
+	.post_recv = i40iw_post_recv,
+	.drain_sq = i40iw_drain_sq,
+	.drain_rq = i40iw_drain_rq,
+	/* CQ operations */
+	.create_cq = i40iw_create_cq,
+	.destroy_cq = i40iw_destroy_cq,
+	.poll_cq = i40iw_poll_cq,
+	.req_notify_cq = i40iw_req_notify_cq,
+	/* MR operations */
+	.get_dma_mr = i40iw_get_dma_mr,
+	.reg_user_mr = i40iw_reg_user_mr,
+	.dereg_mr = i40iw_dereg_mr,
+	.alloc_mr = i40iw_alloc_mr,
+	.map_mr_sg = i40iw_map_mr_sg,
+	/* Stats operations */
+	.alloc_hw_stats = i40iw_alloc_hw_stats,
+	.get_hw_stats = i40iw_get_hw_stats,
+};
+
 /**
  * i40iw_init_rdma_device - initialization of iwarp device
  * @iwdev: iwarp device
@@ -2786,30 +2830,6 @@ static struct i40iw_ib_device *i40iw_init_rdma_device(struct i40iw_device *iwdev
 	iwibdev->ibdev.phys_port_cnt = 1;
 	iwibdev->ibdev.num_comp_vectors = iwdev->ceqs_count;
 	iwibdev->ibdev.dev.parent = &pcidev->dev;
-	iwibdev->ibdev.query_port = i40iw_query_port;
-	iwibdev->ibdev.query_pkey = i40iw_query_pkey;
-	iwibdev->ibdev.query_gid = i40iw_query_gid;
-	iwibdev->ibdev.alloc_ucontext = i40iw_alloc_ucontext;
-	iwibdev->ibdev.dealloc_ucontext = i40iw_dealloc_ucontext;
-	iwibdev->ibdev.mmap = i40iw_mmap;
-	iwibdev->ibdev.alloc_pd = i40iw_alloc_pd;
-	iwibdev->ibdev.dealloc_pd = i40iw_dealloc_pd;
-	iwibdev->ibdev.create_qp = i40iw_create_qp;
-	iwibdev->ibdev.modify_qp = i40iw_modify_qp;
-	iwibdev->ibdev.query_qp = i40iw_query_qp;
-	iwibdev->ibdev.destroy_qp = i40iw_destroy_qp;
-	iwibdev->ibdev.create_cq = i40iw_create_cq;
-	iwibdev->ibdev.destroy_cq = i40iw_destroy_cq;
-	iwibdev->ibdev.get_dma_mr = i40iw_get_dma_mr;
-	iwibdev->ibdev.reg_user_mr = i40iw_reg_user_mr;
-	iwibdev->ibdev.dereg_mr = i40iw_dereg_mr;
-	iwibdev->ibdev.alloc_hw_stats = i40iw_alloc_hw_stats;
-	iwibdev->ibdev.get_hw_stats = i40iw_get_hw_stats;
-	iwibdev->ibdev.query_device = i40iw_query_device;
-	iwibdev->ibdev.drain_sq = i40iw_drain_sq;
-	iwibdev->ibdev.drain_rq = i40iw_drain_rq;
-	iwibdev->ibdev.alloc_mr = i40iw_alloc_mr;
-	iwibdev->ibdev.map_mr_sg = i40iw_map_mr_sg;
 	iwibdev->ibdev.iwcm = kzalloc(sizeof(*iwibdev->ibdev.iwcm), GFP_KERNEL);
 	if (!iwibdev->ibdev.iwcm) {
 		ib_dealloc_device(&iwibdev->ibdev);
@@ -2826,13 +2846,7 @@ static struct i40iw_ib_device *i40iw_init_rdma_device(struct i40iw_device *iwdev
 	iwibdev->ibdev.iwcm->destroy_listen = i40iw_destroy_listen;
 	memcpy(iwibdev->ibdev.iwcm->ifname, netdev->name,
 	       sizeof(iwibdev->ibdev.iwcm->ifname));
-	iwibdev->ibdev.get_port_immutable   = i40iw_port_immutable;
-	iwibdev->ibdev.get_dev_fw_str       = i40iw_get_dev_fw_str;
-	iwibdev->ibdev.poll_cq = i40iw_poll_cq;
-	iwibdev->ibdev.req_notify_cq = i40iw_req_notify_cq;
-	iwibdev->ibdev.post_send = i40iw_post_send;
-	iwibdev->ibdev.post_recv = i40iw_post_recv;
-	iwibdev->ibdev.get_vector_affinity = i40iw_get_vector_affinity;
+	ib_set_device_ops(&iwibdev->ibdev, &i40iw_dev_ops);
 
 	return iwibdev;
 }